Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1)
@@ -951,399 +778,130 @@
           nzt_mg(i) = nzt_l
 
-          nxl_l = nxl_l / 2
+          nxl_l = nxl_l / 2 
           nxr_l = nxr_l / 2
-          nys_l = nys_l / 2
-          nyn_l = nyn_l / 2
-          nzt_l = nzt_l / 2
-
+          nys_l = nys_l / 2 
+          nyn_l = nyn_l / 2 
+          nzt_l = nzt_l / 2 
        ENDDO
 
-!
-!--    Temporary problem: Currently calculation of maxerror in routine poismg crashes if grid data
-!--    are collected on PE0 already on the finest grid level.
-!--    To be solved later.
-       IF ( maximum_grid_level == mg_switch_to_pe0_level )  THEN
-          message_string = 'grid coarsening on subdomain level cannot be performed'
-          CALL message( 'poismg', 'PA0236', 1, 2, 0, 6, 0 )
-       ENDIF
-
     ELSE
 
-       maximum_grid_level = 0
-
-    ENDIF
-
-!
-!-- Default level 0 tells exchange_horiz that all ghost planes have to be exchanged. grid_level is
-!-- adjusted in poismg, where only one ghost plane is required.
-    grid_level = 0
+       maximum_grid_level = 1
+
+    ENDIF
+
+    grid_level = maximum_grid_level
 
 #if defined( __parallel )
 !
 !-- Gridpoint number for the exchange of ghost points (y-line for 2D-arrays)
-    ngp_y  = nyn - nys + 1 + 2 * nbgp
-
-!
-!-- Define new MPI derived datatypes for the exchange of ghost points in x- and y-direction for
-!-- 2D-arrays (line)
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_REAL, type_x, ierr )
+    ngp_y  = nyn - nys + 1
+
+!
+!-- Define a new MPI derived datatype for the exchange of ghost points in
+!-- y-direction for 2D-arrays (line)
+    CALL MPI_TYPE_VECTOR( nxr-nxl+3, 1, ngp_y+2, MPI_REAL, type_x, ierr )
     CALL MPI_TYPE_COMMIT( type_x, ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_REAL, type_y, ierr )
-    CALL MPI_TYPE_COMMIT( type_y, ierr )
-!
-!-- Define new MPI derived datatypes for the exchange of ghost points in x- and y-direction for
-!-- 2D-INTEGER arrays (line) - on normal grid.
-!-- Define types for 32-bit and 8-bit Integer. The 8-bit Integer are only required on normal grid,
-!-- while 32-bit Integer may be also required on coarser grid level in case of multigrid solver.
-!
-!-- 8-bit Integer
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_BYTE, type_x_byte, ierr )
-    CALL MPI_TYPE_COMMIT( type_x_byte, ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_BYTE, type_y_byte, ierr )
-    CALL MPI_TYPE_COMMIT( type_y_byte, ierr )
-!
-!-- 32-bit Integer
-    ALLOCATE( type_x_int(0:maximum_grid_level), type_y_int(0:maximum_grid_level) )
-
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_INTEGER, type_x_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_x_int(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_INTEGER, type_y_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_y_int(0), ierr )
-!
-!-- Calculate gridpoint numbers for the exchange of ghost points along x (yz-plane for 3D-arrays)
-!-- and define MPI derived data type(s) for the exchange of ghost points in y-direction (xz-plane).
-!-- Do these calculations for the model grid and (if necessary) also for the coarser grid levels
-!-- used in the multigrid method
-    ALLOCATE ( ngp_xz(0:maximum_grid_level),                                                       &
-               ngp_xz_int(0:maximum_grid_level),                                                   &
-               ngp_yz(0:maximum_grid_level),                                                       &
-               ngp_yz_int(0:maximum_grid_level),                                                   &
-               type_xz(0:maximum_grid_level),                                                      &
-               type_xz_int(0:maximum_grid_level),                                                  &
-               type_yz(0:maximum_grid_level),                                                      &
-               type_yz_int(0:maximum_grid_level) )
+    CALL MPI_TYPE_VECTOR( nxr-nxl+3, 1, ngp_y+2, MPI_INTEGER, type_x_int, ierr )
+    CALL MPI_TYPE_COMMIT( type_x_int, ierr )
+
+!
+!-- Calculate gridpoint numbers for the exchange of ghost points along x
+!-- (yz-plane for 3D-arrays) and define MPI derived data type(s) for the
+!-- exchange of ghost points in y-direction (xz-plane).
+!-- Do these calculations for the model grid and (if necessary) also
+!-- for the coarser grid levels used in the multigrid method
+    ALLOCATE ( ngp_yz(maximum_grid_level), type_xz(maximum_grid_level) )
 
     nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
-
-!
-!-- Discern between the model grid, which needs nbgp ghost points and grid levels for the multigrid
-!-- scheme. In the latter case only one ghost point is necessary.
-!-- First definition of MPI-datatypes for exchange of ghost layers on normal grid. The following
-!-- loop is needed for data exchange in poismg.f90.
-!
-!-- Determine number of grid points of yz-layer for exchange
-    ngp_yz(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
-
-!
-!-- Define an MPI-datatype for the exchange of left/right boundaries.
-!-- Although data are contiguous in physical memory (which does not necessarily require an
-!-- MPI-derived datatype), the data exchange between left and right PE's using the MPI-derived type
-!-- is 10% faster than without.
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz(0), MPI_REAL, type_xz(0),     &
-                          ierr )
-    CALL MPI_TYPE_COMMIT( type_xz(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz(0), ngp_yz(0), MPI_REAL, type_yz(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_yz(0), ierr )
-
-!
-!-- Define data types for exchange of 3D Integer arrays.
-    ngp_yz_int(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
-
-    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz_int(0), MPI_INTEGER,          &
-                          type_xz_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_xz_int(0), ierr )
-
-    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz_int(0), ngp_yz_int(0), MPI_INTEGER, type_yz_int(0), ierr )
-    CALL MPI_TYPE_COMMIT( type_yz_int(0), ierr )
-
-!
-!-- Definition of MPI-datatypes for multigrid method (coarser level grids)
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-!
-!--    Definition of MPI-datatyoe as above, but only 1 ghost level is used
-       DO  i = maximum_grid_level, 1 , -1
-!
-!--       For 3D-exchange on different multigrid level, one ghost point for REAL arrays, two ghost
-!--       points for INTEGER arrays
-          ngp_xz(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
-          ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
-
-          ngp_xz_int(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
-          ngp_yz_int(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
-!
-!--       MPI data type for REAL arrays, for xz-layers
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), MPI_REAL, type_xz(i),     &
-                                ierr )
-          CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
-
-!
-!--       MPI data type for INTEGER arrays, for xz-layers
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz_int(i), MPI_INTEGER,          &
-                                type_xz_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_xz_int(i), ierr )
-
-!
-!--       MPI data type for REAL arrays, for yz-layers
-          CALL MPI_TYPE_VECTOR( 1, ngp_yz(i), ngp_yz(i), MPI_REAL, type_yz(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_yz(i), ierr )
-!
-!--       MPI data type for INTEGER arrays, for yz-layers
-          CALL MPI_TYPE_VECTOR( 1, ngp_yz_int(i), ngp_yz_int(i), MPI_INTEGER, type_yz_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_yz_int(i), ierr )
-
-
-!--       For 2D-exchange of INTEGER arrays on coarser grid level, where 2 ghost points need to be
-!--       exchanged. Only required for 32-bit Integer arrays.
-          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+5, 2, nyn_l-nys_l+5, MPI_INTEGER, type_x_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_x_int(i), ierr )
-
-
-          CALL MPI_TYPE_VECTOR( 2, nyn_l-nys_l+5, nyn_l-nys_l+5, MPI_INTEGER, type_y_int(i), ierr )
-          CALL MPI_TYPE_COMMIT( type_y_int(i), ierr )
-
-          nxl_l = nxl_l / 2
-          nxr_l = nxr_l / 2
-          nys_l = nys_l / 2
-          nyn_l = nyn_l / 2
-          nzt_l = nzt_l / 2
-
-       ENDDO
-
-    ENDIF
-
+         
+    DO i = maximum_grid_level, 1 , -1
+       ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
+
+       CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), &
+                             MPI_REAL, type_xz(i), ierr )
+       CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
+
+       nxl_l = nxl_l / 2 
+       nxr_l = nxr_l / 2
+       nys_l = nys_l / 2 
+       nyn_l = nyn_l / 2 
+       nzt_l = nzt_l / 2 
+    ENDDO
 #endif
 
 #if defined( __parallel )
 !
-!-- Setting of flags for inflow/outflow/nesting conditions.
+!-- Setting of flags for inflow/outflow conditions in case of non-cyclic
+!-- horizontal boundary conditions. Set variables for extending array u (v)
+!-- by one gridpoint on the left/rightmost (northest/southest) processor
     IF ( pleft == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation'  .OR.  bc_lr == 'nested'  .OR.                          &
-            bc_lr == 'nesting_offline' )  THEN
-          bc_dirichlet_l  = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
-          bc_radiation_l = .TRUE.
+       IF ( bc_lr == 'dirichlet/neumann' )  THEN
+          inflow_l  = .TRUE.
+       ELSEIF ( bc_lr == 'neumann/dirichlet' )  THEN
+          outflow_l = .TRUE.
        ENDIF
     ENDIF
 
     IF ( pright == MPI_PROC_NULL )  THEN
-       IF ( bc_lr == 'dirichlet/radiation' )  THEN
-          bc_radiation_r = .TRUE.
-       ELSEIF ( bc_lr == 'radiation/dirichlet'  .OR.  bc_lr == 'nested'  .OR.                      &
-                bc_lr == 'nesting_offline' )  THEN
-          bc_dirichlet_r  = .TRUE.
-       ENDIF
+       IF ( bc_lr == 'dirichlet/neumann' )  THEN
+          outflow_r = .TRUE.
+       ELSEIF ( bc_lr == 'neumann/dirichlet' )  THEN
+          inflow_r  = .TRUE.
+       ENDIF
+       uxrp      = 1
     ENDIF
 
     IF ( psouth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
-          bc_radiation_s = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet'  .OR.  bc_ns == 'nested'  .OR.                      &
-                bc_ns == 'nesting_offline' )  THEN
-          bc_dirichlet_s  = .TRUE.
+       IF ( bc_ns == 'dirichlet/neumann' )  THEN
+          outflow_s = .TRUE.
+       ELSEIF ( bc_ns == 'neumann/dirichlet' )  THEN
+          inflow_s  = .TRUE.
        ENDIF
     ENDIF
 
     IF ( pnorth == MPI_PROC_NULL )  THEN
-       IF ( bc_ns == 'dirichlet/radiation'  .OR.  bc_ns == 'nested'  .OR.                          &
-            bc_ns == 'nesting_offline' )  THEN
-          bc_dirichlet_n  = .TRUE.
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-          bc_radiation_n = .TRUE.
-       ENDIF
-    ENDIF
-!
-!-- In case of synthetic turbulence geneartor determine ids.
-!-- Please note, if no forcing or nesting is applied, the generator is applied only at the left
-!-- lateral boundary.
-    IF ( syn_turb_gen )  THEN
-       IF ( bc_dirichlet_l )  THEN
-          id_stg_left_l = myidx
-       ELSE
-          id_stg_left_l = 0
-       ENDIF
-       IF ( bc_dirichlet_r )  THEN
-          id_stg_right_l = myidx
-       ELSE
-          id_stg_right_l = 0
-       ENDIF
-       IF ( bc_dirichlet_s )  THEN
-          id_stg_south_l = myidy
-       ELSE
-          id_stg_south_l = 0
-       ENDIF
-       IF ( bc_dirichlet_n )  THEN
-          id_stg_north_l = myidy
-       ELSE
-          id_stg_north_l = 0
-       ENDIF
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_left_l, id_stg_left,   1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_right_l, id_stg_right, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_south_l, id_stg_south, 1, MPI_INTEGER, MPI_SUM, comm1dy, ierr )
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_stg_north_l, id_stg_north, 1, MPI_INTEGER, MPI_SUM, comm1dy, ierr )
-
-    ENDIF
-
-!
-!-- Broadcast the id of the inflow PE
-    IF ( bc_dirichlet_l )  THEN
-       id_inflow_l = myidx
+       IF ( bc_ns == 'dirichlet/neumann' )  THEN
+          inflow_n  = .TRUE.
+       ELSEIF ( bc_ns == 'neumann/dirichlet' )  THEN
+          outflow_n = .TRUE.
+       ENDIF
+       vynp      = 1
+    ENDIF
+
+!
+!-- Additional MPI derived data type for the exchange of ghost points along x
+!-- needed in case of non-cyclic boundary conditions along y on the northmost
+!-- processors (for the exchange of the enlarged v array)
+    IF ( bc_ns /= 'cyclic'  .AND.  pnorth == MPI_PROC_NULL )  THEN
+       ngp_yz_p = ( nzt - nzb + 2 ) * ( nyn + vynp - nys + 3 )
+       CALL MPI_TYPE_VECTOR( nxr-nxl+3, nzt-nzb+2, ngp_yz_p, &
+                             MPI_REAL, type_xz_p, ierr )
+       CALL MPI_TYPE_COMMIT( type_xz_p, ierr )
+    ENDIF
+#else
+    IF ( bc_lr == 'dirichlet/neumann' )  THEN
+       inflow_l  = .TRUE.
+       outflow_r = .TRUE.
+       uxrp      = 1
+    ELSEIF ( bc_lr == 'neumann/dirichlet' )  THEN
+       outflow_l = .TRUE.
+       inflow_r  = .TRUE.
+    ENDIF
+
+    IF ( bc_ns == 'dirichlet/neumann' )  THEN
+       inflow_n  = .TRUE.
+       outflow_s = .TRUE.
+    ELSEIF ( bc_ns == 'neumann/dirichlet' )  THEN
+       outflow_n = .TRUE.
+       inflow_s  = .TRUE.
+       vynp      = 1
+    ENDIF
+#endif
+
+    IF ( psolver == 'poisfft_hybrid' )  THEN
+       CALL poisfft_hybrid_ini
     ELSE
-       id_inflow_l = 0
-    ENDIF
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( id_inflow_l, id_inflow, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
-
-!
-!-- Broadcast the id of the recycling plane
-!-- WARNING: needs to be adjusted in case of inflows other than from left side!
-    IF ( turbulent_inflow ) THEN
-
-       IF ( NINT( recycling_width / dx, KIND=idp ) >= nxl  .AND.                                   &
-            NINT( recycling_width / dx, KIND=idp ) <= nxr )  THEN
-          id_recycling_l = myidx
-       ELSE
-          id_recycling_l = 0
-       ENDIF
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_recycling_l, id_recycling, 1, MPI_INTEGER, MPI_SUM, comm1dx, ierr )
-
-    ENDIF
-
-!
-!-- Broadcast the id of the outflow PE and outflow-source plane
-    IF ( turbulent_outflow )  THEN
-
-       IF ( bc_radiation_r )  THEN
-          id_outflow_l = myidx
-       ELSE
-          id_outflow_l = 0
-       ENDIF
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_outflow_l, id_outflow, 1, MPI_INTEGER, MPI_SUM, &
-                           comm1dx, ierr )
-
-       IF ( NINT( outflow_source_plane / dx ) >= nxl  .AND.                                        &
-            NINT( outflow_source_plane / dx ) <= nxr )  THEN
-          id_outflow_source_l = myidx
-       ELSE
-          id_outflow_source_l = 0
-       ENDIF
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( id_outflow_source_l, id_outflow_source, 1, MPI_INTEGER, MPI_SUM,        &
-                           comm1dx, ierr )
-
-    ENDIF
-
-    CALL location_message( 'creating virtual PE grids + MPI derived data types', 'finished' )
-
-#else
-    IF ( bc_lr == 'dirichlet/radiation' )  THEN
-       bc_dirichlet_l = .TRUE.
-       bc_radiation_r = .TRUE.
-    ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
-       bc_radiation_l = .TRUE.
-       bc_dirichlet_r = .TRUE.
-    ENDIF
-
-    IF ( bc_ns == 'dirichlet/radiation' )  THEN
-       bc_dirichlet_n = .TRUE.
-       bc_radiation_s = .TRUE.
-    ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-       bc_radiation_n = .TRUE.
-       bc_dirichlet_s = .TRUE.
-    ENDIF
-#endif
-
-!
-!-- At the inflow or outflow, u or v, respectively, have to be calculated for one more grid point.
-    IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
-       nxlu = nxl + 1
-    ELSE
-       nxlu = nxl
-    ENDIF
-    IF ( bc_dirichlet_s  .OR.  bc_radiation_s )  THEN
-       nysv = nys + 1
-    ELSE
-       nysv = nys
-    ENDIF
-
-!
-!-- Allocate wall flag arrays used in the multigrid solver
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-
-       DO  i = maximum_grid_level, 1, -1
-
-           SELECT CASE ( i )
-
-              CASE ( 1 )
-                 ALLOCATE( wall_flags_1(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 2 )
-                 ALLOCATE( wall_flags_2(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 3 )
-                 ALLOCATE( wall_flags_3(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 4 )
-                 ALLOCATE( wall_flags_4(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 5 )
-                 ALLOCATE( wall_flags_5(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 6 )
-                 ALLOCATE( wall_flags_6(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 7 )
-                 ALLOCATE( wall_flags_7(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 8 )
-                 ALLOCATE( wall_flags_8(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 9 )
-                 ALLOCATE( wall_flags_9(nzb:nzt_mg(i)+1,                                           &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE ( 10 )
-                 ALLOCATE( wall_flags_10(nzb:nzt_mg(i)+1,                                          &
-                                        nys_mg(i)-1:nyn_mg(i)+1,                                   &
-                                        nxl_mg(i)-1:nxr_mg(i)+1) )
-
-              CASE DEFAULT
-                 message_string = 'more than 10 multigrid levels'
-                 CALL message( 'init_pegrid', 'PA0238', 1, 2, 0, 6, 0 )
-
-          END SELECT
-
-       ENDDO
-
+       CALL poisfft_init
     ENDIF
 
Index: palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 1)
@@ -1,44 +1,30 @@
-!> @file init_pt_anomaly.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE init_pt_anomaly
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: init_pt_anomaly.f90,v $
+! Revision 1.7  2005/03/26 20:36:55  raasch
+! Arguments for non-cyclic boundary conditions added to argument list of
+! routine exchange_horiz
 !
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
+! Revision 1.6  2001/03/30 07:32:28  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
+! Revision 1.5  2001/01/22 19:40:09  letzel
+! All comments translated into English.
 !
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
+! Revision 1.4  2001/01/22 07:19:14  raasch
+! Module test_variables removed
 !
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
+! Revision 1.3  1998/07/06 12:17:25  raasch
+! + USE test_variables
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! Added topography flags
+! Revision 1.2  1997/09/12 06:26:16  raasch
+! Stoerungsradius jetzt proportional zur Gitterweite
 !
 ! Revision 1.1  1997/08/29 08:58:56  raasch
@@ -48,110 +34,50 @@
 ! Description:
 ! ------------
-!> Impose a temperature perturbation for an advection test.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE init_pt_anomaly
+! Impose a temperature perturbation for an advection test.
+!------------------------------------------------------------------------------!
 
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  pt, zu
-
+    USE arrays_3d
+    USE constants
+    USE grid_variables
+    USE indices
     USE control_parameters
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE grid_variables,                                                                            &
-        ONLY:  dx, dy
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nzb, nzt, wall_flags_total_0
-
-    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !< grid index along x
-    INTEGER(iwp) ::  ic !< center index along x
-    INTEGER(iwp) ::  j  !< grid index along y
-    INTEGER(iwp) ::  jc !< center index along y
-    INTEGER(iwp) ::  k  !< grid index along z
-    INTEGER(iwp) ::  kc !< center index along z
-
-    REAL(wp)     ::  amount                               !< amount of temperature perturbation
-    REAL(wp)     ::  bubble_center_y                      !< center of bubble in y
-    REAL(wp)     ::  bubble_center_z = 170.0              !< center of bubble in z
-    REAL(wp)     ::  bubble_sigma_y = 300.0               !< width of bubble in y
-    REAL(wp)     ::  bubble_sigma_z = 150.0               !< width of bubble in z
-    REAL(wp)     ::  flag                                 !< flag to mask topography grid points
-    REAL(wp)     ::  initial_temperature_difference = 0.4 !< temperature perturbation for bubble in K
-    REAL(wp)     ::  radius                               !< radius of pt anomaly
-    REAL(wp)     ::  rc                                   !< radius of pt anomaly
-    REAL(wp)     ::  x                                    !< x dimension of pt anomaly
-    REAL(wp)     ::  y                                    !< y dimension of pt anomaly
-    REAL(wp)     ::  z                                    !< z dimension of pt anomaly
-
+    INTEGER ::  i, ic, j, jc, k, kc
+    REAL    ::  betrag, radius, rc, x, y, z
 
 !
 !-- Defaults: radius rc, strength z,
-!--           position of center: ic, jc, kc
-    rc =  10.0_wp * dx
+!--           position of centre: ic, jc, kc
+    rc =  10.0 * dx
     ic =  ( nx+1 ) / 2
     jc =  ic
-    kc =  nzt / 2
+    kc = nzt / 2
 
-    IF ( INDEX( initializing_actions, 'initialize_ptanom' ) /= 0 )  THEN
 !
-!--    Compute the perturbation.
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-!
-!--             Predetermine flag to mask topography
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!-- Compute the perturbation.
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt-1
+             x = ( i - ic ) * dx
+             y = ( j - jc ) * dy
+             z = ABS( zu(k) - zu(kc) )
+             radius = SQRT( x**2 + y**2 + z**2 )
+             IF ( radius <= rc )  THEN
+                betrag = 5.0 * EXP( -( radius / 2.0 )**2 )
+             ELSE
+                betrag = 0.0
+             ENDIF
 
-                x = ( i - ic ) * dx
-                y = ( j - jc ) * dy
-                z = ABS( zu(k) - zu(kc) )
-                radius = SQRT( x**2 + y**2 + z**2 )
-                IF ( radius <= rc )  THEN
-                   amount = 5.0_wp * EXP( -( radius * 0.001_wp / 2.0_wp )**2 )
-                ELSE
-                   amount = 0.0_wp
-                ENDIF
+             pt(k,j,i) = pt(k,j,i) + betrag
 
-                pt(k,j,i) = pt(k,j,i) + amount * flag
-
-             ENDDO
           ENDDO
        ENDDO
-
-!
-!-- Initialize warm air bubble close to surface and homogenous elegonated along x-Axis
-    ELSEIF ( INDEX( initializing_actions, 'initialize_bubble' ) /= 0 )  THEN
-!
-!--    Calculate y-center of model domain
-       bubble_center_y = ( ny + 1.0 ) * dy / 2.0
-
-!
-!--    Compute perturbation for potential temperaure
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-!
-!--             Predetermine flag to mask topography
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-                pt(k,j,i) = pt(k,j,i) +                                                            &
-                               EXP( -0.5 * ( (j* dy - bubble_center_y) / bubble_sigma_y )**2) *    &
-                               EXP( -0.5 * ( (zu(k) - bubble_center_z) / bubble_sigma_z)**2)  *    &
-                               initial_temperature_difference * flag
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDIF
+    ENDDO
 
 !
 !-- Exchange of boundary values for temperature
-    CALL exchange_horiz( pt, nbgp )
+    CALL exchange_horiz( pt, 0, 0 )
 
 
